using System;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;

using Belikov.GenuineChannels.Messaging;

namespace KnownLayer
{
	/// <summary>
	/// Represents a very very important business object!
	/// </summary>
	public class ImportantBusinessData
	{
		private struct ImportantBusinessData_ValueTypes
		{
			public long l;
			public int i;
			public DateTime dt;
			public Guid guid;
		}

		private ImportantBusinessData_ValueTypes valueTypes;

		private string message1;
		private ImportantBusinessData anotherImportantInformation;

		public long L
		{
			get
			{
				return this.valueTypes.l;
			}
			set
			{
				this.valueTypes.l = value;
			}
		}

		public int I
		{
			get
			{
				return this.valueTypes.i;
			}
			set
			{
				this.valueTypes.i = value;
			}
		}

		public DateTime DT
		{
			get
			{
				return this.valueTypes.dt;
			}
			set
			{
				this.valueTypes.dt = value;
			}
		}

		public Guid Guid
		{
			get
			{
				return this.valueTypes.guid;
			}
			set
			{
				this.valueTypes.guid = value;
			}
		}

		public string Message1
		{
			get
			{
				return this.message1;
			}
			set
			{
				this.message1 = value;
			}
		}

		public ImportantBusinessData ImportantInformation
		{
			get
			{
				return this.anotherImportantInformation;
			}
			set
			{
				this.anotherImportantInformation = value;
			}
		}

		public unsafe void Serialize(GenuineChunkedStream outputStream, BinaryWriter binaryWriter)
		{
			fixed (ImportantBusinessData_ValueTypes *source = &this.valueTypes)
				outputStream.Write((byte *) source, 0, sizeof(ImportantBusinessData_ValueTypes));

			binaryWriter.Write(this.message1);
			binaryWriter.Write(this.anotherImportantInformation != null);

			if (this.anotherImportantInformation != null)
				this.anotherImportantInformation.Serialize(outputStream, binaryWriter);
		}

		public unsafe static ImportantBusinessData Deserialize(Stream inputStream, BinaryReader binaryReader)
		{
			ImportantBusinessData importantBusinessData = new ImportantBusinessData();
			fixed (ImportantBusinessData_ValueTypes *destination = &importantBusinessData.valueTypes)
				GenuineChunkedStream.Read( (byte *) destination, 0, sizeof(ImportantBusinessData_ValueTypes), inputStream);

			importantBusinessData.message1 = binaryReader.ReadString();
			if (binaryReader.ReadBoolean())
				importantBusinessData.anotherImportantInformation = ImportantBusinessData.Deserialize(inputStream, binaryReader);

			return importantBusinessData;
		}
	}
}
