using System;

using KnownLayer;

namespace Server
{
	/// <summary>
	/// DataReceiver.
	/// </summary>
	public class DataReceiver : MarshalByRefObject, IDataReceiver
	{
		public void DoSomething(VeryImportantBusinessData[] veryImportantBusinessData)
		{
			if (veryImportantBusinessData == null)
				return ;

			Console.WriteLine("{0} items were received. The third item: {1}, {2}, {3}", veryImportantBusinessData.Length, veryImportantBusinessData[2].DT, veryImportantBusinessData[2].Guid.ToString(), veryImportantBusinessData[2].Message1);
		}

		public void DoSomething_OneWay(VeryImportantBusinessData[] veryImportantBusinessData)
		{
			if (veryImportantBusinessData == null)
				return ;

			Console.WriteLine("{0} items were received. The third item: {1}, {2}, {3}", veryImportantBusinessData.Length, veryImportantBusinessData[2].DT, veryImportantBusinessData[2].Guid.ToString(), veryImportantBusinessData[2].Message1);
		}

		/// <summary>
		/// This is to insure that when created as a Singleton, the first instance never dies,
		/// regardless of the expired time.
		/// </summary>
		/// <returns></returns>
		public override object InitializeLifetimeService()
		{
			return null;
		}
	}
}
