using System;
using System.Collections;
using System.Configuration;
using System.IO;
using System.Runtime.Remoting;
using System.Threading;

using Belikov.GenuineChannels;
using Belikov.GenuineChannels.DirectExchange;
using Belikov.GenuineChannels.DotNetRemotingLayer;
using Belikov.GenuineChannels.GenuineTcp;
using Belikov.GenuineChannels.TransportContext;
using Belikov.GenuineChannels.Logbook;
using Belikov.GenuineChannels.Messaging;

using KnownLayer;

namespace Server
{
	/// <summary>
	/// DirectDataReceiver.
	/// </summary>
	public class DirectDataReceiver : IServerServiceEntry
	{
		/// <summary>
		/// Process the message.
		/// </summary>
		/// <param name="stream">The content of the message.</param>
		/// <param name="sender">The remote host that sent this request.</param>
		/// <returns>Null stream.</returns>
		public Stream HandleMessage(Stream stream, HostInformation sender)
		{
			try
			{
				BinaryReader binaryReader = new BinaryReader(stream);
				int quantity = binaryReader.ReadInt32();
				ImportantBusinessData[] important = new ImportantBusinessData[quantity];
				for ( int i = 0; i < quantity; i++ )
					important[i] = ImportantBusinessData.Deserialize(stream, binaryReader);

				Console.WriteLine("{0} items were received. The third item: {1}, {2}, {3}", important.Length, important[2].DT, important[2].Guid.ToString(), important[2].Message1);
			}
			catch(Exception ex)
			{
				Console.WriteLine("Exception during receiving a message: {0}.", ex.Message);
			}
			finally
			{
				stream.Close();
			}

			return Stream.Null;
		}

	}
}
